/*
Ощущение действий с Пульта
*/

package action_sensor

import (
	"BOT/brain/gomeostas"
	"time"
)

////////////////////////////////////////
func init(){

}
/////////////////////////////////////////
var pulsCount=0
var LifeTime=0
var EvolushnStage=0  // стадия развития
var IsStressing=false
// срабатывает с каждым пульсом
func ActionSensorPuls(evolushnStage int,lifeTime int,puls int,isSlipping bool){
	LifeTime=lifeTime
	EvolushnStage=evolushnStage
	pulsCount=puls
	IsStressing=isSlipping
	CheckCurActions()
}

/* список активных действий с Пульта
Могут быть совершены сразу несколько действий, контекст которых удерживаются в течении 10 секунд.
В ActionFromPult сохраняется время активации действия в числе пульсов pulsCount
0 Нет никаких действий с Пульта
1 Непонятно
2 Понятно
3 Наказать
4 Поощрить
5 Накормить
6 Успокоить
7 Предложить поиграть
8 Предложить поучить
9 Игнорировать
10 Сделать больно
11 Сделать приятно
12 Заплакать
13 Засмеяться
14 Обрадоваться
15 Испугаться
16 Простить
17 Вылечить
 */
var ActionFromPult[18]int

// название Базового контекста из его ID str:=action_sensor.GetActionNameFromID(id)
func GetActionNameFromID(id int)(string){
	var out=""
	switch id{
	case 1: out="Непонятно"
	case 2: out="Понятно"
	case 3: out="Наказать"
	case 4: out="Поощрить"
	case 5: out="Накормить"
	case 6: out="Успокоить"
	case 7: out="Предложить поиграть"
	case 8: out="Предложить поучить"
	case 9: out="Игнорировать"
	case 10: out="Сделать больно"
	case 11: out="Сделать приятно"
	case 12: out="Заплакать"
	case 13: out="Засмеяться"
	case 14: out="Обрадоваться"
	case 15: out="Испугаться"
	case 16: out="Простить"
	case 17: out="Вылечить"
	}
	return out
}
//////////////////////////////////////////////


/* акция с пульта
foodPortion - сопровождает акцию Накормить - доза еды в процентах от 100 энергии
 */
var FoodPortionForEnergi=0
func SetActionFromPult(action int,foodPortion int){
	switch action{
	case 1:// Непонятно
		gomeostas.ChangeGomeostazParametr(5, 5.0)
	case 2:// Понятно
	case 3://  Наказать
		gomeostas.ChangeGomeostazParametr(7, 5.0)
	case 4://  Поощрить
		gomeostas.ChangeGomeostazParametr(7, -5.0)
	case 5://  Накормить
		switch foodPortion {
		case 1:
			FoodPortionForEnergi += 10
		case 2:
			FoodPortionForEnergi += 30
		case 3:
			FoodPortionForEnergi += 60
		}
		if FoodPortionForEnergi>100{
			FoodPortionForEnergi=100
		}
	case 6://  Успокоить
		gomeostas.ChangeGomeostazParametr(2, -10.0)
	case 7://  Предложить поиграть
		gomeostas.ChangeGomeostazParametr(4, 10.0)
	case 8://  Предложить поучить
		gomeostas.ChangeGomeostazParametr(5, 10.0)
		gomeostas.ChangeGomeostazParametr(6, 10.0)
	case 9://  Игнорировать
	case 10://  Сделать больно
		gomeostas.ChangeGomeostazParametr(8, 5.0)
	case 11://  Сделать приятно
		gomeostas.ChangeGomeostazParametr(8, -5.0)
		gomeostas.ChangeGomeostazParametr(2, -5.0)
	case 12://  Заплакать
		gomeostas.ChangeGomeostazParametr(2, 5.0)
		gomeostas.ChangeGomeostazParametr(4, 5.0)
	case 13://  Засмеяться
		gomeostas.ChangeGomeostazParametr(6, 10.0)
	case 14://  Обрадоваться
	case 15://  Испугаться
		gomeostas.ChangeGomeostazParametr(7, 5.0)
		gomeostas.ChangeGomeostazParametr(6, 10.0)
	case 16://  Простить
		gomeostas.ChangeGomeostazParametr(2, -10.0)
		gomeostas.ChangeGomeostazParametr(4, 5.0)
	case 17://  Вылечить
		gomeostas.ChangeGomeostazParametr(8, -30.0)
	}

	ActionFromPult[0]=0
	ActionFromPult[action]=pulsCount
	// дезактивировать этот контекст через 10 секунд
	time.AfterFunc(10*time.Second, func() {
		ActionFromPult[action]=0
	})

	//// активировать дерево действием
//	reflexes.ActiveFromAction()
}
//////////////////////////////////////////

// какие акции действуют в данный момент пульса - активные контексты действий с Пульта
func CheckCurActions()([]int){
	var aArr[]int
	for i := 1; i < 18; i++ {
		if ActionFromPult[i]>0{
			aArr=append(aArr,i)
		}
	}
	if aArr==nil{
		ActionFromPult[0]=0
	}
	return aArr
}
////////////////////////////////////////////////