/*  Ориентировочные рефлексы
Привлечение осознанного внимания выявляет конечную цель - найти автоматизм или ничего не делать.
Начинается с Определение Цели в данной ситуации - на уровне наследственных функций
и активных доминант нерешенной проблемы.

Новизна при активации Дерева автоматизмов CurrentAutomatizTreeEnd будет сохранена при выполнении автоматизма в
*/

package psychic

import (
	"BOT/brain/gomeostas"
)

////////////////////////////////////////

var NoveltySituation []int // НОВИЗНА СИТУАЦИИ сохраняет значение CurrentAutomatizTreeEnd[] для решений
var isPeriodResultWaiting=false // идет период ожидания резйльтата автоматизма

/////////////////////////////////////////
// получить инфу после активации дерева рефлексов
var actualRelextActon []int
var veryActualSituation=false
var curTargetArrID []int
func GetReflexInformation(veryActual bool,targetArrID  []int,acrArr []int){
	veryActualSituation=veryActual
	actualRelextActon = acrArr
}
////////////////////////////////////////////


/* автоматизма нет у недоделанной ветки, если нужно то какой-то предположить и сразу проверить
Стадия отсуствия опыта в данных условиях.
 */
func orientation_1()(*Automatizm){

	NoveltySituation=CurrentAutomatizTreeEnd // значение сохраняется в savedNoveltySituation

//  получение текущего состояния информационной среды: отражение Базового состояния и Активных Базовых контекстов
// только при ориентировчном рефлексе - обновление самоощущения! и запись кадра эпизодической памяти
	GetCurrentInformationEnvironment()

	/* Блокировать выполнение рефлексов на время ожидания результата автоматизма
	вызывается из reflex_action.go рефлексов
	*/
	isReflexesActionBloking=true // отмена в automatizm_result.go или просто isReflexesActionBloking=false

	// Определение Цели в данной ситуации - ну уровне наследственных функций
	purpose:=getPurposeGenetic()

	// нужно ли вообще шевелиться?
	// veryActualSituation: плохо для  1, 2, 7 и/или 8  параметров гомеостаза
	if purpose.veryActual{// нужно создавать автоматизм и тут же запускать его
		if purpose.actionID.ID>0 {
			/* сформировать пробный автоматизм моторного действия и сразу запустить его в действие
			   Зафиксироваь время действия
			   10 пульсов следить за измнением состояния и ответными действиями - считать следствием действия
			   оценить результат и скорректировать силу мозжечком в записи автоматизма.

			Выбрать любое действие, т.к. послед создания автоматизма в данной ветке detectedActiveLastNodID
			он уже не вызовет orientation_1(), а будет orientation_2()
			*/
			atmzm:=createAutomatizm(purpose)
			// запустить автоматизм
			if RumAutomatizm(atmzm) {
				// отслеживать последствия в automatizm_result.go
				setAutomatizmRunning(atmzm)
			}
// в automatizm_result.go после оценки результата будет осмысление с активацией Дерева Понимания

			return atmzm
		}
		///////////////////////////////////////
		// игнорировать новое внимание на время ожидания результата автоматизма
		if isPeriodResultWaiting {
			return AutomatizmRunning
		}


// нет действий, попробовать бессмысленно выдать фразы имеющиеся Вериниковские раз нужно что-то срочно делать
			if purpose.veryActual {
				// TODO подобрать хоть как-то ассоциирующуюся фразу из имеющизся
				phraseID:=findSuitablePhrase()
				if len(phraseID)>0{
					purpose.actionID.PhraseID=phraseID
					atmzm:=createAutomatizm(purpose)
					// запустить автоматизм
					if RumAutomatizm(atmzm) {
						// отслеживать последствия в automatizm_result.go
						setAutomatizmRunning(atmzm)
					}
					// в automatizm_result.go после оценки результата будет осмысление с активацией Дерева Понимания
					return atmzm
				}


				// return autmzm
			}
			// TODO Активировать Дерево Понимания

	}else{// нет атаса, можно спокойно поэкспериментивроать, если есть любопытсво
		if gomeostas.BaseContextActive[2] {// активен Поиск
// TODO осмыслить ситуацию - Активировать Дерево Понимания

			//return automatizm
		}
	}
	isReflexesActionBloking=false
	return nil
}
///////////////////////////////////////

/*проверить подходит ли автоматизм defAutomatizmID к текущим условиям, если нет,
- по опыту того, к чему приводят новые условия
режим нахождения альтернативы

! важно: если вернуло автоматизм, значит хочет попробовать
 */
func orientation_2(defAutomatizmID int)(*Automatizm){
	NoveltySituation=CurrentAutomatizTreeEnd

//  получение текущего состояния информационной среды: отражение Базового состояния и Активных Базовых контекстов
// только при ориентировчном рефлексе - обновление самоощущения! и запись эпизодической памяти
	GetCurrentInformationEnvironment()

	/* Блокировать выполнение рефлексов на время ожидания результата автоматизма
	вызывается из reflex_action.go рефлексов
	*/
	isReflexesActionBloking=true // отмена в automatizm_result.go или просто isReflexesActionBloking=false


	atmzm:=AutomatizmFromIdArr[defAutomatizmID]
// ПЛОХОЙ АВТОМАТИЗМ ?!
	if atmzm.Usefulness < 0{ // плохой автоматизм, т.е. в прошлый раз был плохой результат
		// TODO осмыслить ситуацию - Активировать Дерево Понимания

		//return automatizm
	}

	// Определение Цели в данной ситуации - на уровне наследственных функций
	purpose:=getPurposeGenetic()
	if purpose.veryActual{// нужно ли вообще шевелиться?
		//// если есть важные (по опыту) признаки новизны - осмыслить их попробовать более подходящий автоматизм
		// TODO осмыслить ситуацию - Активировать Дерево Понимания

		// срочность и важность ситуации: если очень срочно и важно - просто оставить имеющийся автоматизм
		atmzm:=createAutomatizm(purpose)
		// запустить автоматизм
		if RumAutomatizm(atmzm) {
			// отслеживать последствия в automatizm_result.go ИГНОРИРОВАТЬ ДРУГИЕ ПОКА НЕ БУДЕТ РЕЗУЛЬТАТ
			setAutomatizmRunning(atmzm)
		}

		// в automatizm_result.go после оценки результата будет осмысление с активацией Дерева Понимания
		return atmzm
	}
	////////////////////////////
	// игнорировать новое внимание на время ожидания результата автоматизма
	if isPeriodResultWaiting {
		return AutomatizmRunning
	}

	// НЕТ СРОЧНОСТИ, МОЖНО СПОКОЙНО ПОДУМАТЬ
	//////////// если есть важные (по опыту) признаки новизны - осмыслить их
	/*
	// TODO осмыслить ситуацию - Активировать Дерево Понимания
	 */

	// если не найдено решение
	// TODO осмыслить ситуацию - Активировать Дерево Понимания


	////////////  если нет результата
	isReflexesActionBloking=false
	return nil
}
//////////////////////////////////////////////






